/*     
 **********************************************************************
 *     icardwav.h
 *     Copyright 1999, 2000 Creative Labs, Inc. 
 * 
 ********************************************************************** 
 * 
 *     Date                 Author          Summary of changes 
 *     ----                 ------          ------------------ 
 *     October 20, 1999     Bertrand Lee    base code release 
 * 
 ********************************************************************** 
 * 
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version. 
 * 
 *     This program is distributed in the hope that it will be useful, 
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *     GNU General Public License for more details. 
 * 
 *     You should have received a copy of the GNU General Public 
 *     License along with this program; if not, write to the Free 
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, 
 *     USA. 
 * 
 ********************************************************************** 
 */

#ifndef _ICARDWAV_H
#define _ICARDWAV_H

#define MAX_CARDWAVE_DESC   80

/* Enumeration for SetControl */
enum
{
        WAVESTARTLOOP = 0x10,
        WAVEENDLOOP,
        WAVECURPOS,
        WAVESTOPPOSITION,
        WAVEWRITEPOINTER,
        WAVESETSTOPONLOOP,

        WAVEOBJVOLUME = 0x20,
        WAVEINSTANCEVOLUME,
        WAVEOBJREVERB,
        WAVEINSTANCEREVERB,
        WAVEOBJCHORUS,
        WAVEINSTANCECHORUS,
        WAVEOBJMUTE,
        WAVEVOLFACTOR,
        WAVEREVERBFACTOR,
        WAVECHORUSFACTOR,
        WAVEINSTANCEPITCHOFFSET,
        WAVEINSTANCESEND,

        WAVESYNCHSETUP = 0x30,
        WAVESYNCHSTART,
        WAVESETFREQUENCY,
        WAVESETSTARTFLAG,
        WAVEQUERYACTIVEINST,
        WAVEINSTANCEFILTERQ,
        WAVEINSTANCEFILTERCUTOFF,
        WAVEINSTANCEFORMAT,
};

struct wave_caps 
{
	u32 product_id;
	u32 caps;
	u32 controls;
	u32 maxchannels;
	u32 minrate, maxrate;
	char wavedesc[MAX_CARDWAVE_DESC];
};

#define CARDWAVE_OUT                0x0001
#define CARDWAVE_IN                 0x0002
#define CARDWAVE_ALLOW_DIRECTXFER   0x0004

#define CARDWAVE_CONTROL_VOLUME     0x0001

#define CARDWAVE_PLAY_LOOPING       0x00000001

struct wave_format 
{
	u32 samplingrate;
	u32 bitsperchannel;
	u32 channels;		/* 1 = Mono, 2 = Stereo */
};

/* sblive_wave states */
#define CARDWAVE_STATE_STOPPED     0x0001
#define CARDWAVE_STATE_STARTED     0x0002

#define CARDWAVE_MAXPLAYINST 64

#endif /* _ICARDWAV_H */
