/*     
 **********************************************************************
 *     recmgr.h
 *     Copyright 1999, 2000 Creative Labs, Inc. 
 * 
 ********************************************************************** 
 * 
 *     Date                 Author          Summary of changes 
 *     ----                 ------          ------------------ 
 *     October 20, 1999     Bertrand Lee    base code release 
 * 
 ********************************************************************** 
 * 
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version. 
 * 
 *     This program is distributed in the hope that it will be useful, 
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of 
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 *     GNU General Public License for more details. 
 * 
 *     You should have received a copy of the GNU General Public 
 *     License along with this program; if not, write to the Free 
 *     Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, 
 *     USA. 
 * 
 ********************************************************************** 
 */

#ifndef _RECORDMGR_H
#define _RECORDMGR_H

struct record 
{
	struct emu10k1_card *card;
	u8 *recbuffer;
	u32 recpos;
	int is_stereo;
	int is_16bit;
	u32 recbufsize;
	u32 bufsize;
	u32 bufsizereg;
	u32 bufaddrreg;
	u32 bufidxreg;
	u32 adcctl;
	unsigned long busaddx;
	u32 samplingrate;
	u32 recsrc;
};

/* Recording resources */
#define WAVERECORD_NONE		0x00000000
#define WAVERECORD_AC97		0x00000001
#define WAVERECORD_MIC		0x00000002
#define WAVERECORD_FX		0x00000003

void emu10k1_recmgr_startrecord(struct record *);
void emu10k1_recmgr_stoprecord(struct record *);
int emu10k1_recmgr_setrecsrc(struct record *, u32);


#endif /* _RECORDMGR_H */
